package meerkat.mixer.mixing;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 * Created by Tzlil on 12/17/2015.
 * container for random permutation
 * the permutation is sated in constructor and can't be change
 */
public class RandomPermutation {
      public final int[] permutation;

    /**
     * constructor
     * @param n permutation size
     * @param random
     */
    public RandomPermutation(int n,Random random) {
        this.permutation = generatePermutation(n,random);
    }

    /**
     * generate random permutation ovver [0,n)
     * @param n permutation size
     * @param random
     * @return permutation
     */
    private int[] generatePermutation(int n,Random random){
        List<Integer> numbers= new ArrayList<Integer>(n);
        for (int i = 0; i < n; i++) {
            numbers.add(i);
        }

        int[] result = new int[n];
        int index;
        for (int i = 0; i < n; i++) {
            index = random.nextInt(n - i);
            result[i] = numbers.get(index);
            numbers.remove(index);
        }
        return result;
    }
}
