package meerkat.voting.gui.panels.straight_channel_section;

import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import meerkat.voting.gui.managment.TwoWayNode;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Vladimir Eliezer Tokarev on 8/27/2016.
 * StraightChannelSectionController handle the behavior of select channel section screen
 */
public class StraightChannelSectionController extends TwoWayNode {
    private List<Integer> chanelValue;
    private int pointer;
    private boolean lock;

    @FXML
    private void ProceedToNameSelection(MouseEvent boutonPressed) {
        this.currentStage.close();
        this.currentStage.setScene(this.next.GetCurrentScene());
        this.next.UpdateNode();
        this.currentStage.show();
    }

    @Override
    /**
     * Creates the array of the canel value
     */
    public void UpdateNode() {
        this.pointer = 0;
        this.lock = false;
        this.chanelValue = new ArrayList<>();
        this.chanelValue.add(0);
        this.chanelValue.add(0);
        this.chanelValue.add(0);
        this.chanelValue.add(0);
        this.updateVisualChanel();
    }

    /**
     * Updates the channel in the voters choise
     */
    private void UpdateVotersChoise(){
        this.votersBallot.Votershannel = this.chanelValue;
        System.out.println(this.votersBallot.Votershannel +" "+this.votersBallot.VotersNameSelection +" "+ this.votersBallot.VotersImageSelection);
    }

    /**
     * Updates the visual channel value
     */
    private void updateVisualChanel(){
        for (int i = 0 ; i < 4 ; i ++ ){
            String id = "#textarea_"+i;
            TextField textField = ((TextField)this.currentStage.getScene().lookup(id));
            textField.setText(String.valueOf(this.chanelValue.get(i)));
        }
    }

    @FXML
    private void numberPressed(MouseEvent mousePressed){
        if (!this.lock) {
            String value = ((Button) mousePressed.getSource()).getId().split("_")[1];
            this.chanelValue.set(this.pointer, Integer.parseInt(value));
            this.pointer++;
            this.updateVisualChanel();
            this.UpdateVotersChoise();
            if (this.pointer == 4) {
                this.lock = true;
            }
        }
    }

    @FXML
    private void clearLastNumber(MouseEvent mousePressed){
        if (this.pointer >= 1) {
            int lastValueLocation = this.pointer - 1;
            this.chanelValue.set(lastValueLocation, 0);
            this.currentStage.show();
            this.pointer--;
            this.updateVisualChanel();
            this.UpdateVotersChoise();
            this.lock = false;
        }
    }


}
